Skip to main content
`Ctrl`+`K`

# MatSolveTranspose

Solves \(A^T x = b\), given a factored matrix.

## Synopsis

    #include "petscmat.h"
    PetscErrorCode MatSolveTranspose(Mat mat, Vec b, Vec x)

Neighbor-wise Collective

## Input Parameters

- mat - the factored matrix

- b - the right-hand-side vector

## Output Parameter

- x - the result vector

## Notes

The vectors `b` and `x` cannot be the same. I.e., one cannot call `MatSolveTranspose`(A,x,x).

Most users should employ the `KSP` interface for linear solvers instead of working directly with matrix algebra routines such as this. See, e.g., `KSPCreate()`.

## See Also

Matrices, `Mat`, `MatGetFactor()`, `KSP`, `MatSolve()`, `MatSolveAdd()`, `MatSolveTransposeAdd()`

## Level

developer

## Location

src/mat/interface/matrix.c

## Implementations

MatSolveTranspose_MKL_CPARDISO() in src/mat/impls/aij/mpi/mkl_cpardiso/mkl_cpardiso.c
MatSolveTranspose_MUMPS() in src/mat/impls/aij/mpi/mumps/impl/imumps.c
MatSolveTranspose_SeqAIJ() in src/mat/impls/aij/seq/aijfact.c
MatSolveTranspose_KLU() in src/mat/impls/aij/seq/klu/klu.c
MatSolveTranspose_MKL_PARDISO() in src/mat/impls/aij/seq/mkl_pardiso/mkl_pardiso.c
MatSolveTranspose_SeqAIJCUSPARSE() in src/mat/impls/aij/seq/seqcusparse/aijcusparse.cu
MatSolveTranspose_SeqAIJHIPSPARSE() in src/mat/impls/aij/seq/seqhipsparse/aijhipsparse.hip.cxx
MatSolveTranspose_SPQR() in src/mat/impls/aij/seq/spqr/aijspqr.c
MatSolveTranspose_SuperLU() in src/mat/impls/aij/seq/superlu/superlu.c
MatSolveTranspose_UMFPACK() in src/mat/impls/aij/seq/umfpack/umfpack.c

Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages